<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex11.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex11.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex11.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex11.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 11: Asking Questions</h1>
                <p>Now it is time to pick up the pace.  You are doing a lot of printing to get you familiar with typing simple things, but those simple things are fairly boring.  What we want to do now is get data into your programs.  This is a little tricky because you have to learn to do two things that may not make sense right away but trust me and do it anyway.  It will make sense in a few exercises.</p>
<p>Most of what software does is the following:</p>
<ol class="arabic simple">
<li>Take some kind of input from a person.</li>
<li>Change it.</li>
<li>Print out something to show how it changed.</li>
</ol>
<p>So far you have been printing strings, but you haven't been able to get any input from a person.  You may not even know what &quot;input&quot; means, but type this code in anyway and make it exactly the same.  In the next exercise we'll do more to explain input.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4
5
6
7
8
9</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex11.py-idio.html-1"></a><span class="k">print</span> <span class="s2">&quot;How old are you?&quot;</span><span class="p">,</span>
<a name="python--ex11.py-idio.html-2"></a><span class="n">age</span> <span class="o">=</span> <span class="nb">raw_input</span><span class="p">()</span>
<a name="python--ex11.py-idio.html-3"></a><span class="k">print</span> <span class="s2">&quot;How tall are you?&quot;</span><span class="p">,</span>
<a name="python--ex11.py-idio.html-4"></a><span class="n">height</span> <span class="o">=</span> <span class="nb">raw_input</span><span class="p">()</span>
<a name="python--ex11.py-idio.html-5"></a><span class="k">print</span> <span class="s2">&quot;How much do you weigh?&quot;</span><span class="p">,</span>
<a name="python--ex11.py-idio.html-6"></a><span class="n">weight</span> <span class="o">=</span> <span class="nb">raw_input</span><span class="p">()</span>
<a name="python--ex11.py-idio.html-7"></a>
<a name="python--ex11.py-idio.html-8"></a><span class="k">print</span> <span class="s2">&quot;So, you&#39;re </span><span class="si">%r</span><span class="s2"> old, </span><span class="si">%r</span><span class="s2"> tall and </span><span class="si">%r</span><span class="s2"> heavy.&quot;</span> <span class="o">%</span> <span class="p">(</span>
<a name="python--ex11.py-idio.html-9"></a>    <span class="n">age</span><span class="p">,</span> <span class="n">height</span><span class="p">,</span> <span class="n">weight</span><span class="p">)</span>
</pre></div>
</td></tr></table><div class="note">
<p class="first admonition-title">Note</p>
<p class="last">We put a <tt class="docutils literal">,</tt> (comma) at the end of each <tt class="docutils literal">print</tt> line.
This is so <tt class="docutils literal">print</tt> doesn't end the line with a newline character and go
to the next line.</p>
</div>
<div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<div class="highlight"><pre><span></span><a name="python--ex11.sh-idio-shint-pyg.html-1"></a><span class="gp">$</span> python ex11.py
<a name="python--ex11.sh-idio-shint-pyg.html-2"></a><span class="go">How old are you? 38</span>
<a name="python--ex11.sh-idio-shint-pyg.html-3"></a><span class="go">How tall are you? 6&#39;2&quot;</span>
<a name="python--ex11.sh-idio-shint-pyg.html-4"></a><span class="go">How much do you weigh? 180lbs</span>
<a name="python--ex11.sh-idio-shint-pyg.html-5"></a><span class="go">So, you&#39;re &#39;38&#39; old, &#39;6\&#39;2&quot;&#39; tall and &#39;180lbs&#39; heavy.</span>
</pre></div></div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Go online and find out what Python's <tt class="docutils literal">raw_input</tt> does.</li>
<li>Can you find other ways to use it?  Try some of the samples you find.</li>
<li>Write another &quot;form&quot; like this to ask some other questions.</li>
<li>Related to escape sequences, try to find out why the last line has <tt class="docutils literal"><span class="pre">'6\'2&quot;'</span></tt> with that <tt class="docutils literal">\'</tt> sequence.  See how the single-quote needs to be escaped because otherwise it would end the string?</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>How do I get a number from someone so I can do math?</dt>
<dd>That's a little advanced, but try <tt class="docutils literal">x = <span class="pre">int(raw_input())</span></tt> which gets the number as a string from <tt class="docutils literal">raw_input()</tt> then converts it to an integer using <tt class="docutils literal">int()</tt>.</dd>
<dt>I put my height into raw input like this <tt class="docutils literal"><span class="pre">raw_input(&quot;6'2&quot;)</span></tt> but it doesn't work.</dt>
<dd>You don't put your height in there, you type it directly into your Terminal.  First thing is, go back and make the code exactly like mine.  Next, run the script, and when it pauses, type your height in at your keyboard.  That's all there is to it.</dd>
<dt>Why do you have a newline on line 8 instead of putting it on one line?</dt>
<dd>That's so that the line is less than 80 characters long, which is a style that Python programmers like.  You could put it on one line if you like.</dd>
<dt>What's the difference between <tt class="docutils literal">input()</tt> and <tt class="docutils literal">raw_input()</tt>?</dt>
<dd>The <tt class="docutils literal">input()</tt> function will try to convert things you enter as if they were Python code, but it has security problems so you should avoid it.</dd>
<dt>When my strings print out there's a <tt class="docutils literal">u</tt> in front of them, as in <tt class="docutils literal">u'35'</tt>.</dt>
<dd>That's how Python tells you that the string is Unicode.  Use a <tt class="docutils literal">%s</tt> format instead and you'll see it printed like normal.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex11.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex11.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
